package SAE.ApiREST.WebService.service;
import SAE.ApiREST.WebService.model.Collect;
import SAE.ApiREST.WebService.model.Teacher;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import SAE.ApiREST.WebService.model.Article;
import org.springframework.stereotype.Service;
import SAE.ApiREST.WebService.model.Collect;

@Service
public class StubCollectionService implements ICollectionService {
    private List<Collect> collects = new ArrayList<>();

    public StubCollectionService(){
        this.collects.add(new Collect("collect1",  new Teacher(1, "12-03-2023", "aline.alipres@gmail.com", "MsGarconManque"),0));

        Collect collection2 = new Collect("collect2",  new Teacher(1, "12-03-2023", "aline.alipres@gmail.com", "MsGarconManque"),1);
        collection2.addArticle(new Article("toi","azezeaea", LocalDate.now().minusMonths(1),LocalDate.now().minusMonths(2),true,1));
        this.collects.add(collection2);

        Collect collection3 = new Collect("collect3",  new Teacher(1, "12-03-2023", "aline.alipres@gmail.com", "MsGarconManque"),3);
        collection3.addArticle(new Article("toi","azezeaea",LocalDate.now().minusMonths(1),LocalDate.now().minusMonths(2),true,1));
        collection3.addArticle(new Article("toi","azezeaea",LocalDate.now().minusMonths(1),LocalDate.now().minusMonths(2),true,1));
        this.collects.add(collection3);
    }

    @Override
    public List<Collect> getAllCollections() {
        return collects;
    }

    // region Collection

    // region GET
    @Override
    public Collect getCollectionById(Integer id){
        try {
            return collects.get(id);
        }catch (Exception e){
            return null;
        }
    }

    @Override
    public List<Collect> getAllCollectionsByName(String name){
        ArrayList<Collect> repCollections = new ArrayList<Collect>();
        for(Collect collection : collects){
            if(Objects.equals(collection.getName(), name)) {
                repCollections.add(collection);
            }
        }
        return repCollections;
    }
    // endregion

    // region DELETE
    @Override
    public void deleteColletionById(Integer id){
        Collect collection = getCollectionById(id);
        collects.remove(collection);
    }

    @Override
    public void deleteColletionByName(String name){
        List<Collect> collectionsByName = getAllCollectionsByName(name);
        collects.remove(collectionsByName.get(0));
    }

    @Override
    public void deleteAllColletionByName(String name){
        List<Collect> collectionsByName = getAllCollectionsByName(name);
        collects.removeAll(collectionsByName);
    }

    @Override
    public void addCollection(Collect collection) {
        collects.add(collection);
    }
    // endregion

    // region PUT
    @Override
    public void addCollections(List<Collect> collections){
        collects.addAll(collections);
    }
    // endregion

    // region POST
    @Override
    public void modifyCollectionName(Collect collection, String name){
        collection.setName(name);
    }

    @Override
    public void modifyCollectionNameById(Integer id, String name){
        Collect collection = getCollectionById(id);
        modifyCollectionName(collection,name);
    }
    // endregion
    // endregion

    // region Article
    @Override
    public List<Article> getAllArticlesById(Integer id){
        List<Article> result = new ArrayList<>();
        Collect collect = getCollectionById(id);
        if (result.addAll(collect.getAllArticles())){
            return result;
        }
        return null;
    }
    @Override
    public void addArticle(Collect collect, Article article){
        collect.addArticle(article);
    }
    @Override
    public void deleteArticle(Collect collect, Article article){
        collect.removeArticle(article);
    }
    //  endregion
}